Adding job to detect if distribution can work offline
[releng/builder.git] / jjb / integration / include-raw-integration-deploy-controller-offline.sh
1 # Create a script to run controller inside a dynamic jenkins slave
2 DISTRIBUTION="karaf"
3 CONTROLLERFEATURES="odl-integration-compatible-with-all"
4 CONTROLLERMEM="3072m"
5
6 if [ ${BUNDLEURL} == 'last' ]; then
7     NEXUSPATH="https://nexus.opendaylight.org/content/repositories/opendaylight.snapshot/org/opendaylight/integration/distribution-${DISTRIBUTION}"
8     # Extract the BUNDLEVERSION from the pom.xml
9     BUNDLEVERSION=`xpath pom.xml '/project/version/text()' 2> /dev/null`
10     echo "Bundle version is $BUNDLEVERSION"
11     # Acquire the timestamp information from maven-metadata.xml
12     wget ${NEXUSPATH}/${BUNDLEVERSION}/maven-metadata.xml
13     TIMESTAMP=`xpath maven-metadata.xml "//snapshotVersion[extension='zip'][1]/value/text()" 2>/dev/null`
14     echo "Nexus timestamp is $TIMESTAMP"
15     BUNDLEFOLDER="distribution-${DISTRIBUTION}-${BUNDLEVERSION}"
16     BUNDLE="distribution-${DISTRIBUTION}-${TIMESTAMP}.zip"
17     BUNDLEURL="${NEXUSPATH}/${BUNDLEVERSION}/${BUNDLE}"
18     echo "Distribution bundle URL is ${BUNDLEURL}"
19 else
20     BUNDLE="$(echo "$BUNDLEURL" | awk -F '/' '{ print $(NF) }')"
21     BUNDLEFOLDER="${BUNDLE//.zip}"
22 fi
23
24 echo "Downloading the distribution from ${BUNDLEURL}"
25 wget --no-verbose  ${BUNDLEURL}
26
27 echo "Extracting the new controller..."
28 unzip -q ${BUNDLE}
29
30 echo "Configuring the startup features..."
31 cd ${BUNDLEFOLDER}/etc
32 CFG=org.apache.karaf.features.cfg
33 cp ${CFG} ${CFG}.bak
34 cat ${CFG}.bak | sed "s/^featuresBoot=.*/featuresBoot=config,standard,region,package,kar,ssh,management,${CONTROLLERFEATURES}/" > ${CFG}.1
35 cat ${CFG}.1 | sed "s%mvn:org.opendaylight.integration/features-integration-index/${BUNDLEVERSION}/xml/features%mvn:org.opendaylight.integration/features-integration-index/${BUNDLEVERSION}/xml/features,mvn:org.opendaylight.integration/features-integration-test/${BUNDLEVERSION}/xml/features%" > ${CFG}
36 cat ${CFG}
37
38 echo "Configuring the log..."
39 LOG=org.ops4j.pax.logging.cfg
40 cp ${LOG} ${LOG}.bak
41 cat ${LOG}.bak | sed 's/log4j.appender.out.maxFileSize=1MB/log4j.appender.out.maxFileSize=20MB/' > ${LOG}
42 cat ${LOG}
43
44 echo "Configure the repos..."
45 REPO=org.ops4j.pax.url.mvn.cfg
46 cp ${REPO} ${REPO}.bak
47 cat ${REPO}.bak | sed '/http/d' | sed '$s/...$//'> ${REPO}
48 cat ${REPO}
49
50 echo "Configure max memory..."
51 MEM=setenv
52 cd ../bin
53 cp ${MEM} ${MEM}.bak
54 cat ${MEM}.bak | sed 's/JAVA_MAX_MEM="2048m"/JAVA_MAX_MEM="${CONTROLLERMEM}"/' > ${MEM}
55 cat ${MEM}
56
57 echo "Starting controller..."
58 ./start &
59
60 echo "sleeping for 20 seconds..."
61 sleep 20
62
63 echo "Check OSGi bundles..."
64 ./client "feature:install ${CONTROLLERFEATURES}" || echo $? > ${WORKSPACE}/error.txt
65
66 echo "Fetching Karaf log"
67 cd ${WORKSPACE}
68 cp ${BUNDLEFOLDER}/data/log/karaf.log .
69
70 echo "Exit with error"
71 if [ `cat error.txt` -ne 0 ]; then
72     echo "Failed to deploy offline"
73     exit 1
74 fi
75
76 # vim: ts=4 sw=4 sts=4 et ft=sh :
77